#!/usr/bin/env python
import sys,os,time,socket,signal,struct

def reset(hostName):
    """Reset a devicemaster using TCP Admin command"""
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    signal.alarm(5)
    s.connect((hostName,4606))
    s.send(struct.pack("<BBHL",13,0,8,0))
    s.close()
    signal.alarm(0)
    time.sleep(1)

def downloadFile(hostName,fileName,go=0,quiet=0,skip=0):
    """Download a binary file using TCP Admin command"""
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    signal.alarm(5)
    s.connect((hostName,4606))
    f = open(fileName)
    bytecount = len(f.read(skip))
    while 1:
        signal.alarm(1)
        data = f.read(1400)
        if not data: break;
        length = len(data)
        header = struct.pack("<BBHL",1,0,length+8,bytecount)
        if not quiet: print "%7d:%d" % (bytecount,length)
        time.sleep(0.02)
        s.send(header+data)
        bytecount = bytecount + length
    if not quiet: print "downloaded %d bytes" % bytecount
    if go:
        if not quiet: print "starting program"
        s.send(struct.pack("<BBHL",3,0,8,skip))
    f.close()
    s.close()

r = 0    
g = 0
q = 0
s = 0
args = sys.argv
def usage():
    print "Usage: %s [-gqsr] hostname filename" % sys.argv[0]
    print "           -g   send go command to start program"
    print "           -q   quiet mode (do not show packets)"
    print "           -r   reset DM before downloading"
    print "           -s   skip vector area (use with gdb)"
    sys.exit(0)

while 1:
    if (len(args) < 2) or (args[1][0] != '-'): break
    for opt in args[1][1:]:
        if   opt == 'g': g = 1
        elif opt == 's': s = 0x140
        elif opt == 'q': q = 1
        elif opt == 'r': r = 1
        else: usage()
    del args[1]
        
if len(args) == 3:
    if r: reset(args[1])
    downloadFile(args[1],args[2],go=g,quiet=q,skip=s)
else:
    usage()

